/*
PeRdr - PE file disassembler
Copyright (C) 1999-2003 Frediano Ziglio
-----

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-----

INFORMATION
  www: http://freddy77.tripod.com/perdr/
  e-mail: freddy77@angelfire.com
*/
#ifndef FILE_CODESCAN_H
#define FILE_CODESCAN_H

class IMachineStatus
{
public:
  // quando il flusso si separa copia lo stato
  virtual IMachineStatus* Clone() const=0;
  virtual ~IMachineStatus() {};
};

class CodeParser;
class IScanning
{
public:
  // crea uno stato adeguato per il flusso
  virtual IMachineStatus* CreateMachineStatus() const =0;
  // processa istruzione. Ritorna false se si deve fermare il processo
  virtual bool ProcessInstruction(vma_t address,const Instruction& instr,
                                  IMachineStatus* status,CodeParser& codeInfo)=0;
  virtual ~IScanning() {};
};

bool ExecuteComplexReference(vma_t address);

#endif //FILE_CODESCAN_H
