/*
PeRdr - PE file disassembler
Copyright (C) 1999-2006 Frediano Ziglio
-----

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-----

INFORMATION
  www: http://freddy77.tripod.com/perdr/
  e-mail: freddy77@angelfire.com
*/
#ifndef FILE_FILE_HPP
#define FILE_FILE_HPP

#ifndef __STDIO_H
#  include <stdio.h>
#endif

// !!! please use standard iostream is faster and cleaner
class ICFile
{
public:
  enum StringFlag
  {
    strUcs2=32,
    strLen8 = 1, strLen16 = 2, strLen32 = 3, strLenMask =3
  };
  virtual ~ICFile() {};
  virtual void Seek(long offset,int whence=SEEK_SET) const=0;
  // !!! this two members should not exist
  // use ReadString (ICFile) !!!
  virtual char *ReadString(int delim=0) const=0;
  virtual char *ReadStringFlag(unsigned flag) const=0;
  virtual long Tell() const =0;
  virtual void RawRead(void *ptr,size_t size) const=0;
  virtual void RawWrite(const void *ptr,size_t size)=0;
};

// semplice incapsulamento C con eccezioni
class CFile:public ICFile
{
public:
  CFile(const char* filename,const char* mode);
  ~CFile();
  void Seek(long offset,int whence=SEEK_SET) const;
  char *ReadString(int delim=0) const;
  char *ReadStringFlag(unsigned flag) const;
  long Tell() const;
  void RawRead(void *ptr,size_t size) const;
  void RawWrite(const void *ptr,size_t size);
  FILE *GetFile() { return file; };
private:
  void Close();
  FILE* file;
};

template <class T>
inline void RawRead(ICFile& file,T& x)
{
  file.RawRead(&x,sizeof(T));
}

template <class T>
inline void RawWrite(ICFile& file,const T& x)
{
  file.RawWrite(&x,sizeof(T));
}

#endif // FILE_FILE_HPP
