/*
PeRdr - PE file disassembler
Copyright (C) 1999-2002 Frediano Ziglio
-----

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-----

INFORMATION
  www: http://freddy77.tripod.com/perdr/
  e-mail: freddy77@angelfire.com
*/
#ifndef FILE_GLOBAL_H
#define FILE_GLOBAL_H

#include <cstdio>
#include <cstdlib>
#include "utils/bitcompat.h"

#ifdef HAVE_CONFIG_H
#include "../config.h"
#endif

#if BYTEORDER != 1234
#error Sorry, this program work only on little-endian machines
#endif

#if defined(_WIN32) || defined(_Windows) || defined(WIN32)
# ifndef WIN32
#  define WIN32 1
# endif
#endif

#ifdef _MSC_VER
// disabilita warning nome tipo troppo lungo per VC++
#pragma warning( disable : 4786 )
#pragma warning( disable : 4503 )
// disabilita warning unknown pragma per VC++
#pragma warning( disable : 4068 )
#endif

#undef HAVE_HDRSTOP
#if defined(_MSC_VER) || defined(__BORLANDC__)
#define HAVE_HDRSTOP
#endif

typedef uint32_t vma_t;
#define VMA_MIN 0
#define VMA_MAX 0xfffffffflu
typedef unsigned char uchar;

struct OutOfAddress
{
  OutOfAddress(vma_t addr):address(addr) {};
  vma_t address;
};

#ifdef __GNUC__
#define stricmp strcasecmp
#endif

// !!! other file
#define FOR_EACH_BEGIN(type,container,iter) \
{ type::iterator __end = container.end(); \
for(type::iterator iter = container.begin(); iter != __end; ++iter) {
#define FOR_EACH_END(type,container,iter) } }

#define FOR_EACH_CONST_BEGIN(type,container,iter) \
{ type::const_iterator __end = container.end(); \
for(type::const_iterator iter = container.begin(); iter != __end; ++iter) {
#define FOR_EACH_CONST_END(type,container,iter) } }

#define ALLOF(container) container.begin(),container.end()

// !!! for VC++
#undef __min

template <class T>
inline const T& f77_min(const T& a,const T& b)
{
  return (a<b)?a:b;
}

#include "debug.h"

#endif  //FILE_GLOBAL_H
