/*
PeRdr - PE file disassembler
Copyright (C) 1999-2003 Frediano Ziglio
-----

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-----

INFORMATION
  www: http://freddy77.tripod.com/perdr/
  e-mail: freddy77@angelfire.com
*/
#ifndef FILE_HEURISTIC_H
#define FILE_HEURISTIC_H

#include "codeglob.h"

class CodeParser;
class THeuristicMotor
{
public:
  THeuristicMotor(const CodeParser& codeInfo);
  bool ProcessSecure(CodeParser& codeInfo)   
  { return Process(2,ByteInfo::priSafeHeuristics,codeInfo); };
  bool ProcessUnsecure(CodeParser& codeInfo) 
  { return Process(1,ByteInfo::priHeuristics,codeInfo); };
protected:
  typedef std::list<vma_t> TAddress;
  typedef std::map < vma_t, TAddress, std::less<vma_t> > TConstCallCount;
  TConstCallCount constCallCount;
  TConstCallCount globalVarCount;
  TAddresses callApi;
private:
  bool Process(unsigned minimun,enum ByteInfo::TPriority priority,CodeParser& codeInfo);
};

#endif // FILE_HEURISTIC_H
