/*
PeRdr - PE file disassembler
Copyright (C) 1999-2002 Frediano Ziglio
-----

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-----

INFORMATION
  www: http://freddy77.tripod.com/perdr/
  e-mail: freddy77@angelfire.com
*/
#include "global.h"
#ifdef HAVE_HDRSTOP
#pragma hdrstop
#endif

#include "references.h"

// inserisce un riferimento. Inserisce anche il suo inverso
void IstrReferences::Add(vma_t from,vma_t to,enum FlowTypes type, bool isApi)
{
  refs.insert(IstrReference(from, to,   true,  type, isApi));
  refs.insert(IstrReference(to,   from, false, type, isApi));
}

bool IstrReferences::IsPresent(vma_t from,vma_t to) const
{
  return refs.find(IstrReference(from,to)) != refs.end();
}

IstrReferences::iterator IstrReferences::beginReferenceTo(vma_t addr) const
{
  return refs.lower_bound(IstrReference(addr,0));
}

IstrReferences::iterator IstrReferences::endReferenceTo(vma_t addr) const
{
  return refs.lower_bound(IstrReference(addr+1,0));
}
