/*
PeRdr - PE file disassembler
Copyright (C) 1999-2006 Frediano Ziglio
-----

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-----

INFORMATION
  www: http://freddy77.tripod.com/perdr/
  e-mail: freddy77@angelfire.com
*/
#ifndef FILE_RVA_H
#define FILE_RVA_H

#include <stdexcept>
#include <utility>

// forward declaration
struct _PE_IMAGE_SECTION_HEADER;
typedef struct _PE_IMAGE_SECTION_HEADER PE_IMAGE_SECTION_HEADER;

//#include "code.h"
class PeSection
{
public:
  PeSection() {};
  PeSection(const PE_IMAGE_SECTION_HEADER& section) { *this = section; };
  void operator=(const PE_IMAGE_SECTION_HEADER& section);
  bool IsCode() const;
  uint32_t RvaSize;
  uint32_t RvaAddress;
  uint32_t RawSize;
  uint32_t RawAddress;
private:
  uint32_t Characteristics;
};

class RVAFileTranslator
{
public:
  RVAFileTranslator(const PE_IMAGE_SECTION_HEADER* _sections,unsigned _num_section);
  ~RVAFileTranslator();
  RVAFileTranslator(const RVAFileTranslator& rhs):section_infos(NULL)
  { (*this) = rhs; };
  void operator=(const RVAFileTranslator& rhs);
  long RVA2File(uint32_t rva) const;
  uint32_t File2RVA(long file) const;
  long RVA2FileSafe(uint32_t rva) const {
    long r = RVA2File(rva); if (r==0) throw std::runtime_error("Invalid RVA");
    return r;
  };
  uint32_t File2RVASafe(long file) const {
    uint32_t r = File2RVA(file); if (r==0) throw std::runtime_error("Invalid File offset");
    return r;
  };
  unsigned GetSectionCount() const
  { return num; }
  const PeSection* GetSection(unsigned n) const
  { return ((n<num)?&section_infos[n]:NULL); };
private:
  unsigned num;
//  section_info *section_infos;
  PeSection *section_infos;
};

#endif //FILE_RVA_H
