/*
PeRdr - PE file disassembler
Copyright (C) 1999-2006 Frediano Ziglio
-----

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-----

INFORMATION
  www: http://freddy77.tripod.com/perdr/
  e-mail: freddy77@angelfire.com
*/
#ifndef FILE_X86INSTR_H
#define FILE_X86INSTR_H

#include "x86istr.h"
#include "param.h"
#include "registers.h"

#include "references.h"

class Instruction
{
public:
  struct UseTypeUnimplemented
  {
  public:
    UseTypeUnimplemented(enum x86instructions _instr):instr(_instr) {};
    enum x86instructions instr;
  };
  enum UseType {
    // simple types
    useNone =0, useOverwrite =1, useModify =2, useRead =4,
    // composet types
    useReadWrite = useOverwrite|useRead, useReadModify = useModify|useRead,
    // maschere utili
    useMaskChange = useOverwrite|useModify
  };
  Instruction()
  {
    numArg = 0;
    instruction = -1;
    segOver = -1;
    repPrefix = -1;
  };
  // calcola l'uso che si fa di un registro, se sovrascrittura param
  // conterra' il nuovo valore
  enum UseType GetUseType(reg_t reg,Param* param = NULL) const;
  void Write(char* buffer) const;
  void WriteRegUsage(FILE* f) const;
  enum FlowTypes GetFlowType() const;
  // test if the instruction is a no-op
  bool IsNop() const;
  int instruction;
  int numArg;
  signed char segOver;
  signed char repPrefix;
  Param Args[3];  // numero parametri massimi
};

#endif //FILE_X86INSTR_H
